import { defineStore, mapStores } from 'pinia';

export const useLayoutStore = defineStore('layout', {
    state: () => ({
        minDesktopWidth: 992,
        isDesktop: Boolean,
        isEtapeListRetracted: Boolean,
        isHamburgerMenuOpen: false,
    }),
    actions: {
        setupResizeListenner () {
            this.isDesktop = window.innerWidth >= this.minDesktopWidth ? true : false;
            window.addEventListener('resize', () => {
                this.isDesktop = window.innerWidth >= this.minDesktopWidth ? true : false;
            })
            this.isEtapeListRetracted = this.isDesktop ? false : true;
        },
        collapseEtapeListe(listeEtape) {
            listeEtape.classList.add('retracted');
            setTimeout(() => {
                listeEtape.closest('.layout__region').classList.add('retracted');
                listeEtape.nextElementSibling.classList.add('retracted');
                listeEtape.classList.add('disapeared');
            }, 300);
            this.isEtapeListRetracted = true;
        },
        expandEtapeListe(listeEtape) {
            listeEtape.closest('.layout__region').classList.remove('retracted');
            listeEtape.nextElementSibling.classList.remove('retracted');
            listeEtape.classList.remove('disapeared');
            setTimeout(() => {
                listeEtape.classList.remove('retracted');
            }, 300);
            this.isEtapeListRetracted = false;
        },
        setUpHamburgerToggle(menuBurger, menuContainer) {
            const menuTitle = document.querySelector('#menu-title');
            const menuH2 = document.querySelector('#menu > h2');

            menuBurger.addEventListener('click', (e) => { 
              setTimeout(() => {
                  if (!this.isHamburgerMenuOpen) menuContainer.style.display = 'block';
                  menuContainer.classList.toggle('open');
                  menuTitle.classList.toggle('open');
                  menuBurger.classList.toggle('open');
                  menuH2.classList.toggle('open');
                  if (this.isHamburgerMenuOpen) {
                    setTimeout(() => {
                        menuContainer.style.display = 'none';
                        this.isHamburgerMenuOpen = !this.isHamburgerMenuOpen;
                    }, 300);
                  }
              }, 50);
              document.addEventListener('click', (e) => {
                if (!menuContainer.contains(e.target) && !menuBurger.contains(e.target)) {
                  menuContainer.classList.remove('open');
                  menuTitle.classList.remove('open');
                  menuBurger.classList.remove('open');
                  menuH2.classList.remove('open');  
                  setTimeout(() => {
                    if (this.isHamburgerMenuOpen) {
                        menuContainer.style.display = 'none';
                    }
                    this.isHamburgerMenuOpen = false;
                  }, 300);
                }
              });
            });
        }
    },
})